#ifndef lint
static const char	RCSid[] = "$Id: mx3.c,v 2.2 2003/02/22 02:07:27 greg Exp $";
#endif

double
mx3d_adjoint(a, b)
register double a[3][3], b[3][3];
{
    b[0][0] =  ((a[1][1])*( a[2][2]) - ( a[1][2])*( a[2][1]));
    b[1][0] =  ((a[1][2])*( a[2][0]) - ( a[1][0])*( a[2][2]));
    b[2][0] =  ((a[1][0])*( a[2][1]) - ( a[1][1])*( a[2][0]));
    b[0][1] =  ((a[2][1])*( a[0][2]) - ( a[2][2])*( a[0][1]));
    b[1][1] =  ((a[2][2])*( a[0][0]) - ( a[2][0])*( a[0][2]));
    b[2][1] =  ((a[2][0])*( a[0][1]) - ( a[2][1])*( a[0][0]));
    b[0][2] =  ((a[0][1])*( a[1][2]) - ( a[0][2])*( a[1][1]));
    b[1][2] =  ((a[0][2])*( a[1][0]) - ( a[0][0])*( a[1][2]));
    b[2][2] =  ((a[0][0])*( a[1][1]) - ( a[0][1])*( a[1][0]));
    return a[0][0]*b[0][0] + a[1][0]*b[0][1] + a[2][0]*b[0][2];
}


mx3d_mul(a, b, c)
register double a[3][3], b[3][3], c[3][3];
{
    c[0][0] = a[0][0]*b[0][0] + a[0][1]*b[1][0] + a[0][2]*b[2][0];
    c[0][1] = a[0][0]*b[0][1] + a[0][1]*b[1][1] + a[0][2]*b[2][1];
    c[0][2] = a[0][0]*b[0][2] + a[0][1]*b[1][2] + a[0][2]*b[2][2];
    c[1][0] = a[1][0]*b[0][0] + a[1][1]*b[1][0] + a[1][2]*b[2][0];
    c[1][1] = a[1][0]*b[0][1] + a[1][1]*b[1][1] + a[1][2]*b[2][1];
    c[1][2] = a[1][0]*b[0][2] + a[1][1]*b[1][2] + a[1][2]*b[2][2];
    c[2][0] = a[2][0]*b[0][0] + a[2][1]*b[1][0] + a[2][2]*b[2][0];
    c[2][1] = a[2][0]*b[0][1] + a[2][1]*b[1][1] + a[2][2]*b[2][1];
    c[2][2] = a[2][0]*b[0][2] + a[2][1]*b[1][2] + a[2][2]*b[2][2];
}


mx3d_transform(p, a, q)
register double p[3], q[3];
register double a[3][3];
{
    q[0] = p[0]*a[0][0] + p[1]*a[1][0] + p[2]*a[2][0];
    q[1] = p[0]*a[0][1] + p[1]*a[1][1] + p[2]*a[2][1];
    q[2] = p[0]*a[0][2] + p[1]*a[1][2] + p[2]*a[2][2];
}


double
mx3d_transform_div(p, a, q)
register double p[3], q[2];
register double a[3][3];
{
    double q2;
    q2 = p[0]*a[0][2] + p[1]*a[1][2] + p[2]*a[2][2];
    if (q2!=0.) {
	q[0] = (p[0]*a[0][0] + p[1]*a[1][0] + p[2]*a[2][0]) / q2;
	q[1] = (p[0]*a[0][1] + p[1]*a[1][1] + p[2]*a[2][1]) / q2;
    }
    return q2;
}


mx3d_translate_mat(tx, ty, m)
double tx, ty;
register double m[3][3];
{
    m[0][0] = 1.; m[0][1] = 0.; m[0][2] = 0.;
    m[1][0] = 0.; m[1][1] = 1.; m[1][2] = 0.;
    m[2][0] = tx; m[2][1] = ty; m[2][2] = 1.;
}


mx3d_translate(m, tx, ty)
register double m[3][3];
double tx, ty;
{
    m[3][0] += tx*m[0][0]+ty*m[1][0];
    m[3][1] += tx*m[0][1]+ty*m[1][1];
    m[3][2] += tx*m[0][2]+ty*m[1][2];
}


mx3d_scale_mat(sx, sy, m)
double sx, sy;
register double m[3][3];
{
    m[0][0] = sx; m[0][1] = 0.; m[0][2] = 0.;
    m[1][0] = 0.; m[1][1] = sy; m[1][2] = 0.;
    m[2][0] = 0.; m[2][1] = 0.; m[2][2] = 1.;
}


mx3d_scale(m, sx, sy)
register double m[3][3];
double sx, sy;
{
    m[0][0] *= sx; m[0][1] *= sx; m[0][2] *= sx;
    m[1][0] *= sy; m[1][1] *= sy; m[1][2] *= sy;
}
